/* ProcessWrapper.c generated by valac 0.36.4, the Vala compiler
 * generated from ProcessWrapper.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*- */
/*
 * Copyright (C) 2012 Victor Eduardo <victoreduardm@gmail.com>
 *
 * Cerbere is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Cerbere is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Cerbere; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor,
 * Boston, MA  02110-1301  USA
 *
 * Authors: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <sys/wait.h>
#include <float.h>
#include <math.h>


#define CERBERE_TYPE_PROCESS_WRAPPER (cerbere_process_wrapper_get_type ())
#define CERBERE_PROCESS_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapper))
#define CERBERE_PROCESS_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapperClass))
#define CERBERE_IS_PROCESS_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CERBERE_TYPE_PROCESS_WRAPPER))
#define CERBERE_IS_PROCESS_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CERBERE_TYPE_PROCESS_WRAPPER))
#define CERBERE_PROCESS_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapperClass))

typedef struct _CerbereProcessWrapper CerbereProcessWrapper;
typedef struct _CerbereProcessWrapperClass CerbereProcessWrapperClass;
typedef struct _CerbereProcessWrapperPrivate CerbereProcessWrapperPrivate;

#define CERBERE_PROCESS_WRAPPER_TYPE_STATUS (cerbere_process_wrapper_status_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define CERBERE_TYPE_SETTINGS_MANAGER (cerbere_settings_manager_get_type ())
#define CERBERE_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CERBERE_TYPE_SETTINGS_MANAGER, CerbereSettingsManager))
#define CERBERE_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CERBERE_TYPE_SETTINGS_MANAGER, CerbereSettingsManagerClass))
#define CERBERE_IS_SETTINGS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CERBERE_TYPE_SETTINGS_MANAGER))
#define CERBERE_IS_SETTINGS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CERBERE_TYPE_SETTINGS_MANAGER))
#define CERBERE_SETTINGS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CERBERE_TYPE_SETTINGS_MANAGER, CerbereSettingsManagerClass))

typedef struct _CerbereSettingsManager CerbereSettingsManager;
typedef struct _CerbereSettingsManagerClass CerbereSettingsManagerClass;
enum  {
	CERBERE_PROCESS_WRAPPER_EXITED_SIGNAL,
	CERBERE_PROCESS_WRAPPER_LAST_SIGNAL
};
static guint cerbere_process_wrapper_signals[CERBERE_PROCESS_WRAPPER_LAST_SIGNAL] = {0};

struct _CerbereProcessWrapper {
	GObject parent_instance;
	CerbereProcessWrapperPrivate * priv;
};

struct _CerbereProcessWrapperClass {
	GObjectClass parent_class;
};

typedef enum  {
	CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE,
	CERBERE_PROCESS_WRAPPER_STATUS_RUNNING,
	CERBERE_PROCESS_WRAPPER_STATUS_TERMINATED
} CerbereProcessWrapperStatus;

struct _CerbereProcessWrapperPrivate {
	guint _crash_count;
	gchar* _command;
	CerbereProcessWrapperStatus _status;
	GPid pid;
	GTimer* timer;
};


static gpointer cerbere_process_wrapper_parent_class = NULL;

GType cerbere_process_wrapper_get_type (void) G_GNUC_CONST;
GType cerbere_process_wrapper_status_get_type (void) G_GNUC_CONST;
#define CERBERE_PROCESS_WRAPPER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapperPrivate))
enum  {
	CERBERE_PROCESS_WRAPPER_DUMMY_PROPERTY,
	CERBERE_PROCESS_WRAPPER_CRASH_COUNT,
	CERBERE_PROCESS_WRAPPER_COMMAND,
	CERBERE_PROCESS_WRAPPER_STATUS
};
CerbereProcessWrapper* cerbere_process_wrapper_new (const gchar* command);
CerbereProcessWrapper* cerbere_process_wrapper_construct (GType object_type, const gchar* command);
static void cerbere_process_wrapper_set_command (CerbereProcessWrapper* self, const gchar* value);
void cerbere_process_wrapper_reset_crash_count (CerbereProcessWrapper* self);
static void cerbere_process_wrapper_set_crash_count (CerbereProcessWrapper* self, guint value);
const gchar* cerbere_process_wrapper_get_command (CerbereProcessWrapper* self);
void cerbere_process_wrapper_run_async (CerbereProcessWrapper* self);
CerbereProcessWrapperStatus cerbere_process_wrapper_get_status (CerbereProcessWrapper* self);
static void cerbere_process_wrapper_set_status (CerbereProcessWrapper* self, CerbereProcessWrapperStatus value);
static void cerbere_process_wrapper_on_process_watch_exit (CerbereProcessWrapper* self, GPid pid, gint status);
static void _cerbere_process_wrapper_on_process_watch_exit_gchild_watch_func (GPid pid, gint status, gpointer self);
static void cerbere_process_wrapper_terminate (CerbereProcessWrapper* self);
GType cerbere_settings_manager_get_type (void) G_GNUC_CONST;
CerbereSettingsManager* cerbere_app_get_settings (void);
guint cerbere_settings_manager_get_crash_time_interval (CerbereSettingsManager* self);
guint cerbere_process_wrapper_get_crash_count (CerbereProcessWrapper* self);
static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void cerbere_process_wrapper_finalize (GObject * obj);
static void _vala_cerbere_process_wrapper_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_cerbere_process_wrapper_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GType cerbere_process_wrapper_status_get_type (void) {
	static volatile gsize cerbere_process_wrapper_status_type_id__volatile = 0;
	if (g_once_init_enter (&cerbere_process_wrapper_status_type_id__volatile)) {
		static const GEnumValue values[] = {{CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE, "CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE", "inactive"}, {CERBERE_PROCESS_WRAPPER_STATUS_RUNNING, "CERBERE_PROCESS_WRAPPER_STATUS_RUNNING", "running"}, {CERBERE_PROCESS_WRAPPER_STATUS_TERMINATED, "CERBERE_PROCESS_WRAPPER_STATUS_TERMINATED", "terminated"}, {0, NULL, NULL}};
		GType cerbere_process_wrapper_status_type_id;
		cerbere_process_wrapper_status_type_id = g_enum_register_static ("CerbereProcessWrapperStatus", values);
		g_once_init_leave (&cerbere_process_wrapper_status_type_id__volatile, cerbere_process_wrapper_status_type_id);
	}
	return cerbere_process_wrapper_status_type_id__volatile;
}


CerbereProcessWrapper* cerbere_process_wrapper_construct (GType object_type, const gchar* command) {
	CerbereProcessWrapper * self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (command != NULL, NULL);
	self = (CerbereProcessWrapper*) g_object_new (object_type, NULL);
	_tmp0_ = command;
	cerbere_process_wrapper_set_command (self, _tmp0_);
	return self;
}


CerbereProcessWrapper* cerbere_process_wrapper_new (const gchar* command) {
	return cerbere_process_wrapper_construct (CERBERE_TYPE_PROCESS_WRAPPER, command);
}


void cerbere_process_wrapper_reset_crash_count (CerbereProcessWrapper* self) {
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	cerbere_process_wrapper_set_crash_count (self, (guint) 0);
	_tmp0_ = self->priv->_command;
	g_message ("ProcessWrapper.vala:46: Crash count of '%s' has been reset", _tmp0_);
}


static void _cerbere_process_wrapper_on_process_watch_exit_gchild_watch_func (GPid pid, gint status, gpointer self) {
	cerbere_process_wrapper_on_process_watch_exit ((CerbereProcessWrapper*) self, pid, status);
}


void cerbere_process_wrapper_run_async (CerbereProcessWrapper* self) {
	const gchar* _tmp0_;
	CerbereProcessWrapperStatus _tmp1_;
	GPid process_id = 0;
	gchar** argvp = NULL;
	gint argvp_length1;
	gint _argvp_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	GTimer* _tmp18_;
	GPid _tmp19_;
	GPid _tmp20_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_command;
	g_debug ("ProcessWrapper.vala:50: STARTING process: %s", _tmp0_);
	_tmp1_ = self->priv->_status;
	if (_tmp1_ == CERBERE_PROCESS_WRAPPER_STATUS_RUNNING) {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->_command;
		g_warning ("ProcessWrapper.vala:53: Process %s is already running. Not starting it" \
" again...", _tmp2_);
		return;
	}
	process_id = (GPid) -1;
	argvp = NULL;
	argvp_length1 = 0;
	_argvp_size_ = argvp_length1;
	{
		const gchar* _tmp3_;
		gchar** _tmp4_ = NULL;
		gint _tmp5_;
		_tmp3_ = self->priv->_command;
		g_shell_parse_argv (_tmp3_, &_tmp5_, &_tmp4_, &_inner_error_);
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
		argvp = _tmp4_;
		argvp_length1 = _tmp5_;
		_argvp_size_ = argvp_length1;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == G_SHELL_ERROR) {
				goto __catch6_g_shell_error;
			}
			argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	goto __finally6;
	__catch6_g_shell_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar** _tmp11_;
		_error_ = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = self->priv->_command;
		_tmp7_ = _error_;
		_tmp8_ = _tmp7_->message;
		g_warning ("ProcessWrapper.vala:64: Not passing any args to %s : %s", _tmp6_, _tmp8_);
		_tmp9_ = self->priv->_command;
		_tmp10_ = g_strdup (_tmp9_);
		_tmp11_ = g_new0 (gchar*, 2 + 1);
		_tmp11_[0] = _tmp10_;
		_tmp11_[1] = NULL;
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
		argvp = _tmp11_;
		argvp_length1 = 2;
		_argvp_size_ = argvp_length1;
		_g_error_free0 (_error_);
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp12_ = argvp;
	_tmp12__length1 = argvp_length1;
	if (_tmp12_ == NULL) {
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	{
		GSpawnFlags flags = 0;
		gchar** _tmp13_;
		gint _tmp13__length1;
		GSpawnFlags _tmp14_;
		GPid _tmp15_ = 0;
		flags = (G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD) | G_SPAWN_STDOUT_TO_DEV_NULL;
		_tmp13_ = argvp;
		_tmp13__length1 = argvp_length1;
		_tmp14_ = flags;
		g_spawn_async (NULL, _tmp13_, NULL, _tmp14_, NULL, NULL, &_tmp15_, &_inner_error_);
		process_id = _tmp15_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch7_g_error;
		}
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* err = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp16_ = err;
		_tmp17_ = _tmp16_->message;
		g_warning ("ProcessWrapper.vala:82: %s", _tmp17_);
		_g_error_free0 (err);
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
		return;
	}
	__finally7:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp18_ = g_timer_new ();
	_g_timer_destroy0 (self->priv->timer);
	self->priv->timer = _tmp18_;
	cerbere_process_wrapper_set_status (self, CERBERE_PROCESS_WRAPPER_STATUS_RUNNING);
	_tmp19_ = process_id;
	self->priv->pid = _tmp19_;
	_tmp20_ = self->priv->pid;
	g_child_watch_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp20_, _cerbere_process_wrapper_on_process_watch_exit_gchild_watch_func, g_object_ref (self), g_object_unref);
	argvp = (_vala_array_free (argvp, argvp_length1, (GDestroyNotify) g_free), NULL);
}


static void cerbere_process_wrapper_on_process_watch_exit (CerbereProcessWrapper* self, GPid pid, gint status) {
	GPid _tmp0_;
	GPid _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_;
	gboolean _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pid;
	_tmp1_ = self->priv->pid;
	if (_tmp0_ != _tmp1_) {
		return;
	}
	_tmp2_ = self->priv->_command;
	g_message ("ProcessWrapper.vala:99: Process '%s' watch exit", _tmp2_);
	_tmp5_ = status;
	_tmp6_ = WIFEXITED (_tmp5_);
	if (_tmp6_) {
		_tmp4_ = TRUE;
	} else {
		gint _tmp7_;
		gboolean _tmp8_;
		_tmp7_ = status;
		_tmp8_ = WIFSIGNALED (_tmp7_);
		_tmp4_ = _tmp8_;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		gint _tmp9_;
		gboolean _tmp10_;
		_tmp9_ = status;
		_tmp10_ = WCOREDUMP (_tmp9_);
		_tmp3_ = _tmp10_;
	}
	if (_tmp3_) {
		cerbere_process_wrapper_terminate (self);
	}
}


static void cerbere_process_wrapper_terminate (CerbereProcessWrapper* self) {
	CerbereProcessWrapperStatus _tmp0_;
	const gchar* _tmp1_;
	GPid _tmp2_;
	gboolean normal_exit = FALSE;
	GTimer* _tmp3_;
	gboolean _tmp18_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_status;
	if (_tmp0_ != CERBERE_PROCESS_WRAPPER_STATUS_RUNNING) {
		return;
	}
	_tmp1_ = self->priv->_command;
	g_message ("ProcessWrapper.vala:111: Process %s is being terminated", _tmp1_);
	_tmp2_ = self->priv->pid;
	g_spawn_close_pid (_tmp2_);
	normal_exit = TRUE;
	_tmp3_ = self->priv->timer;
	if (_tmp3_ != NULL) {
		GTimer* _tmp4_;
		gdouble elapsed_secs = 0.0;
		GTimer* _tmp5_;
		gdouble _tmp6_;
		gdouble crash_time_interval_secs = 0.0;
		CerbereSettingsManager* _tmp7_;
		CerbereSettingsManager* _tmp8_;
		guint _tmp9_;
		guint _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
		_tmp4_ = self->priv->timer;
		g_timer_stop (_tmp4_);
		_tmp5_ = self->priv->timer;
		_tmp6_ = g_timer_elapsed (_tmp5_, NULL);
		elapsed_secs = _tmp6_;
		_tmp7_ = cerbere_app_get_settings ();
		_tmp8_ = _tmp7_;
		_tmp9_ = cerbere_settings_manager_get_crash_time_interval (_tmp8_);
		_tmp10_ = _tmp9_;
		crash_time_interval_secs = ((gdouble) _tmp10_) / 1000.0;
		_tmp11_ = elapsed_secs;
		_tmp12_ = crash_time_interval_secs;
		g_message ("ProcessWrapper.vala:123: ET = %f secs\tMin allowed time = %f", _tmp11_, _tmp12_);
		_tmp13_ = elapsed_secs;
		_tmp14_ = crash_time_interval_secs;
		if (_tmp13_ <= _tmp14_) {
			guint _tmp15_;
			const gchar* _tmp16_;
			guint _tmp17_;
			_tmp15_ = self->priv->_crash_count;
			cerbere_process_wrapper_set_crash_count (self, _tmp15_ + 1);
			normal_exit = FALSE;
			_tmp16_ = self->priv->_command;
			_tmp17_ = self->priv->_crash_count;
			g_warning ("ProcessWrapper.vala:128: PROCESS '%s' CRASHED (#%u)", _tmp16_, _tmp17_);
		}
		_g_timer_destroy0 (self->priv->timer);
		self->priv->timer = NULL;
	}
	cerbere_process_wrapper_set_status (self, CERBERE_PROCESS_WRAPPER_STATUS_TERMINATED);
	_tmp18_ = normal_exit;
	g_signal_emit (self, cerbere_process_wrapper_signals[CERBERE_PROCESS_WRAPPER_EXITED_SIGNAL], 0, self, _tmp18_);
}


guint cerbere_process_wrapper_get_crash_count (CerbereProcessWrapper* self) {
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_crash_count;
	result = _tmp0_;
	return result;
}


static void cerbere_process_wrapper_set_crash_count (CerbereProcessWrapper* self, guint value) {
	g_return_if_fail (self != NULL);
	if (cerbere_process_wrapper_get_crash_count (self) != value) {
		guint _tmp0_;
		_tmp0_ = value;
		self->priv->_crash_count = _tmp0_;
		g_object_notify ((GObject *) self, "crash-count");
	}
}


const gchar* cerbere_process_wrapper_get_command (CerbereProcessWrapper* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_command;
	result = _tmp0_;
	return result;
}


static void cerbere_process_wrapper_set_command (CerbereProcessWrapper* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, cerbere_process_wrapper_get_command (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_command);
		self->priv->_command = _tmp1_;
		g_object_notify ((GObject *) self, "command");
	}
}


CerbereProcessWrapperStatus cerbere_process_wrapper_get_status (CerbereProcessWrapper* self) {
	CerbereProcessWrapperStatus result;
	CerbereProcessWrapperStatus _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_status;
	result = _tmp0_;
	return result;
}


static void cerbere_process_wrapper_set_status (CerbereProcessWrapper* self, CerbereProcessWrapperStatus value) {
	g_return_if_fail (self != NULL);
	if (cerbere_process_wrapper_get_status (self) != value) {
		CerbereProcessWrapperStatus _tmp0_;
		_tmp0_ = value;
		self->priv->_status = _tmp0_;
		g_object_notify ((GObject *) self, "status");
	}
}


static void g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_BOOLEAN) (gpointer data1, gpointer arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_boolean (param_values + 2), data2);
}


static void cerbere_process_wrapper_class_init (CerbereProcessWrapperClass * klass) {
	cerbere_process_wrapper_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CerbereProcessWrapperPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_cerbere_process_wrapper_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_cerbere_process_wrapper_set_property;
	G_OBJECT_CLASS (klass)->finalize = cerbere_process_wrapper_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERBERE_PROCESS_WRAPPER_CRASH_COUNT, g_param_spec_uint ("crash-count", "crash-count", "crash-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERBERE_PROCESS_WRAPPER_COMMAND, g_param_spec_string ("command", "command", "command", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CERBERE_PROCESS_WRAPPER_STATUS, g_param_spec_enum ("status", "status", "status", CERBERE_PROCESS_WRAPPER_TYPE_STATUS, CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	cerbere_process_wrapper_signals[CERBERE_PROCESS_WRAPPER_EXITED_SIGNAL] = g_signal_new ("exited", CERBERE_TYPE_PROCESS_WRAPPER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_BOOLEAN, G_TYPE_NONE, 2, CERBERE_TYPE_PROCESS_WRAPPER, G_TYPE_BOOLEAN);
}


static void cerbere_process_wrapper_instance_init (CerbereProcessWrapper * self) {
	gchar* _tmp0_;
	self->priv = CERBERE_PROCESS_WRAPPER_GET_PRIVATE (self);
	self->priv->_crash_count = (guint) 0;
	_tmp0_ = g_strdup ("");
	self->priv->_command = _tmp0_;
	self->priv->_status = CERBERE_PROCESS_WRAPPER_STATUS_INACTIVE;
	self->priv->pid = (GPid) -1;
	self->priv->timer = NULL;
}


static void cerbere_process_wrapper_finalize (GObject * obj) {
	CerbereProcessWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapper);
	_g_free0 (self->priv->_command);
	_g_timer_destroy0 (self->priv->timer);
	G_OBJECT_CLASS (cerbere_process_wrapper_parent_class)->finalize (obj);
}


GType cerbere_process_wrapper_get_type (void) {
	static volatile gsize cerbere_process_wrapper_type_id__volatile = 0;
	if (g_once_init_enter (&cerbere_process_wrapper_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CerbereProcessWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cerbere_process_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CerbereProcessWrapper), 0, (GInstanceInitFunc) cerbere_process_wrapper_instance_init, NULL };
		GType cerbere_process_wrapper_type_id;
		cerbere_process_wrapper_type_id = g_type_register_static (G_TYPE_OBJECT, "CerbereProcessWrapper", &g_define_type_info, 0);
		g_once_init_leave (&cerbere_process_wrapper_type_id__volatile, cerbere_process_wrapper_type_id);
	}
	return cerbere_process_wrapper_type_id__volatile;
}


static void _vala_cerbere_process_wrapper_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	CerbereProcessWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapper);
	switch (property_id) {
		case CERBERE_PROCESS_WRAPPER_CRASH_COUNT:
		g_value_set_uint (value, cerbere_process_wrapper_get_crash_count (self));
		break;
		case CERBERE_PROCESS_WRAPPER_COMMAND:
		g_value_set_string (value, cerbere_process_wrapper_get_command (self));
		break;
		case CERBERE_PROCESS_WRAPPER_STATUS:
		g_value_set_enum (value, cerbere_process_wrapper_get_status (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_cerbere_process_wrapper_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	CerbereProcessWrapper * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CERBERE_TYPE_PROCESS_WRAPPER, CerbereProcessWrapper);
	switch (property_id) {
		case CERBERE_PROCESS_WRAPPER_CRASH_COUNT:
		cerbere_process_wrapper_set_crash_count (self, g_value_get_uint (value));
		break;
		case CERBERE_PROCESS_WRAPPER_COMMAND:
		cerbere_process_wrapper_set_command (self, g_value_get_string (value));
		break;
		case CERBERE_PROCESS_WRAPPER_STATUS:
		cerbere_process_wrapper_set_status (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



